#include <iostream>
#include <fstream>

using namespace std;
long int a[1010][1010];
int n;
long int absi(long int j)
{
    if(j<0) return -j;
    else return j;
}
long int najudaljenija(int i1, int i2)
{   int u=0;
    for(int i=0;i<n;i++)
    for(int j=0;j<n;j++)
    {
        if (a[i1][i2]>a[i][j])
        {long int k=absi(i1-i)+absi(i2-j); if (k>u)u=k;}
    }
    if(u==0) return -1;
    return u;
}
int main()
{
    ifstream fin("pentranje.in");
    long int q;
    fin>>n;
    for(int i=0;i<n;i++)
    for(int j=0;j<n;j++)
        fin>>a[i][j];
    fin>>q;
    int k;
    ofstream fout("pentranje.out");
    int s,b;
    long int c;
    for(int i=0;i<q;i++)
    {
        fin>>k;
        if(k==2){
                 fin>>s>>b>>c;
                 a[s-1][b-1]=c;
                }
        else {
                fin>>s>>b;
                long int k=najudaljenija(s-1,b-1);
                fout<<k<<endl;
             }

    }
    return 0;
}
